//=============================================================================
//			Utility Functions
//				Programmed by C60
//=============================================================================

#pragma warning(disable : 4996)

#include	<windows.h>
#include	<mbstring.h>
#include	"util.h"


//=============================================================================
//	t@CŎꂽt@C̃TCY擾
//=============================================================================
_int64 GetFileSize_s(char *filename)
{
	HANDLE	handle;
	WIN32_FIND_DATA	FindFileData;

	if((handle = FindFirstFile(filename, &FindFileData)) == INVALID_HANDLE_VALUE) {
		return -1;		// 擾s
	} else {
		FindClose(handle);
		return ((_int64)FindFileData.nFileSizeHigh << 32) + FindFileData.nFileSizeLow; 
 	}
}


//=============================================================================
//	TAB  SPACE ɕϊ(tabcolumn J / ESCV[PXs)
//=============================================================================
char *tab2spc(char *dest, const char *src, int tabcolumn)
{
	int		column = 0;
	char	*dest2;

	dest2 = dest;
	while(*src != '\0') {
		if(*src == '\t') {							// TAB
			src++;
			do {
				*dest++ = ' ';
			}while(++column % tabcolumn);
		} else if(*src == 0x0d || *src == 0x0a) {	// s
			column = 0;
			*dest++ = *src++;
		} else {
			*dest++ = *src++;
			column++;
		}
	}
	*dest = '\0';
	return dest2;
}


//=============================================================================
//	GXP[vV[PX̏
//	J[\ړnGXP[vV[PXɂ͔Ή
//=============================================================================
char *delesc(char *dest, const char *src)
{
	char	*dest2;
	uchar	*src2;
	uchar	*src3;
	size_t	i;
	
	if((src2 = src3 = (uchar *)malloc(strlen(src) + 32)) == NULL) {
		return NULL;
	};

	strcpy((char *)src2, src);

	// 31oCgA '\0' ɂ(8 ȏȂ OK Ȃ͂ǁCÔ߁j
	for(i = strlen((char *)src2); i < strlen((char *)src2) + 31; i++) {
		src2[i] = '\0';
	}

	dest2 = dest;

	while(*src2 != '\0') {
		if(*src2 == 0x1b) {		// GXP[vV[PX
			if(*(src2 + 1) == '[') {
				src2 += 2;
				while(*src2 && (toupper(*src2) < 'A' || toupper(*src2) > 'Z')) {
					if(_ismbblead(*src2)) {
						src2 += 2;
						continue;
					}
					src2++;
				}
				src2++;
			} else if(*(src2 + 1) == '=') {
				src2 += 4;
			} else if(*(src2 + 1) == ')' || *(src2 + 1) == '!') {
				src2 += 3;
			} else {
				src2 += 2;
			}
		} else {
			*dest++ = *src2++;		
		}
	}

	free(src3);
	*dest = '\0';
	return dest2;
}


//=============================================================================
//	QoCgp𔼊pɕϊ
//=============================================================================
char *zen2tohan(char *dest, const char *src)
{
	char *src2;
	char *src3;
	char *dest2;
	int	len;
	static const char *codetable[] = {
		"!",		/*	8540 	*/
		"\"",		/*	8541 	*/
		"#",		/*	8542 	*/
		"$",		/*	8543 	*/
		"%",		/*	8544 	*/
		"&",		/*	8545 	*/
		"'",		/*	8546 	*/
		"(",		/*	8547 	*/
		")",		/*	8548 	*/
		"*",		/*	8549 	*/
		"+",		/*	854a 	*/
		",",		/*	854b 	*/
		"-",		/*	854c 	*/
		".",		/*	854d 	*/
		"/",		/*	854e 	*/
		"0",		/*	854f 	*/
		"1",		/*	8550 	*/
		"2",		/*	8551 	*/
		"3",		/*	8552 	*/
		"4",		/*	8553 	*/
		"5",		/*	8554 	*/
		"6",		/*	8555 	*/
		"7",		/*	8556 	*/
		"8",		/*	8557 	*/
		"9",		/*	8558 	*/
		":",		/*	8559 	*/
		";",		/*	855a 	*/
		"<",		/*	855b 	*/
		"=",		/*	855c 	*/
		">",		/*	855d 	*/
		"?",		/*	855e 	*/
		"@",		/*	855f 	*/
		"A",		/*	8560 	*/
		"B",		/*	8561 	*/
		"C",		/*	8562 	*/
		"D",		/*	8563 	*/
		"E",		/*	8564 	*/
		"F",		/*	8565 	*/
		"G",		/*	8566 	*/
		"H",		/*	8567 	*/
		"I",		/*	8568 	*/
		"J",		/*	8569 	*/
		"K",		/*	856a 	*/
		"L",		/*	856b 	*/
		"M",		/*	856c 	*/
		"N",		/*	856d 	*/
		"O",		/*	856e 	*/
		"P",		/*	856f 	*/
		"Q",		/*	8570 	*/
		"R",		/*	8571 	*/
		"S",		/*	8572 	*/
		"T",		/*	8573 	*/
		"U",		/*	8574 	*/
		"V",		/*	8575 	*/
		"W",		/*	8576 	*/
		"X",		/*	8577 	*/
		"Y",		/*	8578 	*/
		"Z",		/*	8579 	*/
		"[",		/*	857a 	*/
		"\\",		/*	857b 	*/
		"]",		/*	857c 	*/
		"^",		/*	857d 	*/
		"_",		/*	857e 	*/
		"",			/*	857f 	*/
		"`",		/*	8580 	*/
		"a",		/*	8581 	*/
		"b",		/*	8582 	*/
		"c",		/*	8583 	*/
		"d",		/*	8584 	*/
		"e",		/*	8585 	*/
		"f",		/*	8586 	*/
		"g",		/*	8587 	*/
		"h",		/*	8588 	*/
		"i",		/*	8589 	*/
		"j",		/*	858a 	*/
		"k",		/*	858b 	*/
		"l",		/*	858c 	*/
		"m",		/*	858d 	*/
		"n",		/*	858e 	*/
		"o",		/*	858f 	*/
		"p",		/*	8590 	*/
		"q",		/*	8591 	*/
		"r",		/*	8592 	*/
		"s",		/*	8593 	*/
		"t",		/*	8594 	*/
		"u",		/*	8595 	*/
		"v",		/*	8596 	*/
		"w",		/*	8597 	*/
		"x",		/*	8598 	*/
		"y",		/*	8599 	*/
		"z",		/*	859a 	*/
		"{",		/*	859b 	*/
		"|",		/*	859c 	*/
		"}",		/*	859d 	*/
		"E",		/*	859e 	*/
		"",		/*	859f 	*/
		"",		/*	85a0 	*/
		"",		/*	85a1 	*/
		"",		/*	85a2 	*/
		"",		/*	85a3 	*/
		"",		/*	85a4 	*/
		"",		/*	85a5 	*/
		"",		/*	85a6 	*/
		"",		/*	85a7 	*/
		"",		/*	85a8 	*/
		"",		/*	85a9 	*/
		"",		/*	85aa 	*/
		"",		/*	85ab 	*/
		"",		/*	85ac 	*/
		"",		/*	85ad 	*/
		"",		/*	85ae 	*/
		"",		/*	85af 	*/
		"",		/*	85b0 	*/
		"",		/*	85b1 	*/
		"",		/*	85b2 	*/
		"",		/*	85b3 	*/
		"",		/*	85b4 	*/
		"",		/*	85b5 	*/
		"",		/*	85b6 	*/
		"",		/*	85b7 	*/
		"",		/*	85b8 	*/
		"",		/*	85b9 	*/
		"",		/*	85ba 	*/
		"",		/*	85bb 	*/
		"",		/*	85bc 	*/
		"",		/*	85bd 	*/
		"",		/*	85be 	*/
		"",		/*	85bf 	*/
		"",		/*	85c0 	*/
		"",		/*	85c1 	*/
		"",		/*	85c2 	*/
		"",		/*	85c3 	*/
		"",		/*	85c4 	*/
		"",		/*	85c5 	*/
		"",		/*	85c6 	*/
		"",		/*	85c7 	*/
		"",		/*	85c8 	*/
		"",		/*	85c9 	*/
		"",		/*	85ca 	*/
		"",		/*	85cb 	*/
		"",		/*	85cc 	*/
		"",		/*	85cd 	*/
		"",		/*	85ce 	*/
		"",		/*	85cf 	*/
		"",		/*	85d0 	*/
		"",		/*	85d1 	*/
		"",		/*	85d2 	*/
		"",		/*	85d3 	*/
		"",		/*	85d4 	*/
		"",		/*	85d5 	*/
		"",		/*	85d6 	*/
		"",		/*	85d7 	*/
		"",		/*	85d8 	*/
		"",		/*	85d9 	*/
		"",		/*	85da 	*/
		"",		/*	85db 	*/
		"",		/*	85dc 	*/
		"",		/*	85dd 	*/
		"E",		/*	85de 	*/
		"E",		/*	85df 	*/
		"",		/*	85e0 	*/
		"",		/*	85e1 	*/
		"",		/*	85e2 	*/
		"",		/*	85e3 	*/
		"",		/*	85e4 	*/
		"",		/*	85e5 	*/
		"",		/*	85e6 	*/
		"",		/*	85e7 	*/
		"",		/*	85e8 	*/
		"",		/*	85e9 	*/
		"",		/*	85ea 	*/
		"",		/*	85eb 	*/
		"",		/*	85ec 	*/
		"",		/*	85ed 	*/
		"",		/*	85ee 	*/
		"",		/*	85ef 	*/
		"",		/*	85f0 	*/
		"",		/*	85f1 	*/
		"",		/*	85f2 	*/
		"",		/*	85f3 	*/
		"",		/*	85f4 	*/
		"",		/*	85f5 	*/
		"",		/*	85f6 	*/
		"",		/*	85f7 	*/
		"",		/*	85f8 	*/
		"",		/*	85f9 	*/
		"",		/*	85fa 	*/
		"",		/*	85fb 	*/
		""		/*	85fc 	*/
	};

	if((src2 = src3 = (char *)malloc(strlen(src) + 2)) == NULL) {
		return NULL;
	};

	strcpy(src2, src);
	src2[strlen(src2)+1] = '\0';		// 2oCgA '\0' ɂ

	dest2 = dest;
	do {
		if(_ismbblead(*src2)) {		// PoCg
			if(*(uchar *)src2 == 0x85 &&
					*(uchar *)(src2+1) >= 0x40 && *(uchar *)(src2+1) <= 0xfc) {	// 2oCgp
				len = strlen(codetable[*(uchar *)(src2+1) - 0x40]);
				strncpy(dest, codetable[*(uchar *)(src2+1) - 0x40], len);
				src2 += 2;
				dest += len;
			} else {
				*dest++ = *src2++;
				*dest++ = *src2++;
			}
		} else {
			*dest++ = *src2++;
		}
	}while(*src2 != '\0');

	free(src3);
	if(strlen(dest2) > 0) {
		if(*(dest - 1) != '\0') {
			*dest = '\0';
		}
	}
	return dest2;
}
