#pragma once

#include "s98device.h"
#include "s98types.h"
#include <stdio.h>

class S98File
{
  public:
	S98File();
	~S98File();

	bool Open(char* path);
	void Close();

	void Start(void);
	void Stop(void);
	void SetReg(Uint32 reg, Uint32 data);
	void Sync(double num, bool force=false);

  private:
	FILE *m_fp;
	double m_wait;
	bool m_start;
};
