//=============================================================================
//		SSG PCM Driver uPPSDRVv Unit
//			Original Programmed	by NaoNeko.
//			Modified		by Kaja.
//			Windows Converted by C60
//=============================================================================

#ifndef PPSDRV_H
#define PPSDRV_H

#include <windows.h>
//#include "types.h"
//#include "psg.h"

//	DLL  ߂l
#define	_PPSDRV_OK					  0		// I
#define	_ERR_OPEN_PPS_FILE			  1		// PPS JȂ
#define	_ERR_WRONG_PPS_FILE		 	  2		// PPS ̌`قȂĂ
#define	_WARNING_PPS_ALREADY_LOAD	  3		// PPS ͂łɓǂݍ܂Ă
#define	_ERR_OUT_OF_MEMORY			 99		// mۂłȂ

#define	SOUND_44K		 44100
#define	SOUND_22K		 22050
#define	SOUND_11K		 11025

#define	PPSDRV_VER		"0.37"
#define	MAX_PPS				14
//#define vers		0x03
//#define date		"1994/06/08"


typedef int				Sample;
typedef	unsigned char	uchar;
typedef	unsigned int	uint;


#pragma pack( push, enter_include1 )
#pragma pack(1)

typedef struct ppsheadertag
{
	struct {
		WORD	address;				// 擪AhX
		WORD	leng;					// f[^
		BYTE	toneofs;				// K
		BYTE	volumeofs;				// 
	} pcmnum[MAX_PPS];
} PPSHEADER;


#pragma pack( pop, enter_include1 )


class PPSDRV
{
public:
	PPSDRV();
	~PPSDRV();
	
	bool Init(uint r, bool ip);						//     
	bool Stop(void);								// 00H PDR ~
	bool Play(int num, int shift, int volshift);	// 01H PDR Đ
	bool Check(void);								// 02H Đǂcheck
	bool SetParam(int paramno, bool data);			// 05H PDRp[^̐ݒ
	bool GetParam(int paramno);						// 06H PDRp[^̎擾
	
	int Load(char *filename);						// PPS ǂݍ
	bool SetRate(uint r, bool ip);					// [gݒ
	void SetVolume(int vol);						// ʐݒ
	void Mix(Sample* dest, int nsamples);			// 

	PPSHEADER ppsheader;							// PCM̉Fwb_[
	char	pps_file[_MAX_PATH];					// t@C

private:
	bool	interpolation;							// ⊮邩H
	int		rate;
	Sample	*dataarea1;								// PPS ۑp|C^
	bool	single_flag;							// P[hH
	bool	low_cpu_check_flag;						// gōĐH
	bool	keyon_flag;								// Keyon H
	Sample	EmitTable[16];
	Sample	*data_offset1;
	Sample	*data_offset2;
	int		data_xor1;								// ݂̈ʒu()
	int		data_xor2;								// ݂̈ʒu()
	int		tick1;
	int		tick2;
	int		tick_xor1;
	int		tick_xor2;
	int		data_size1;
	int		data_size2;
	int		volume1;
	int		volume2;
	Sample	keyoff_vol;
//	PSG		psg;									// @b

};

#endif	// PPSDRV_H
