#pragma once

enum {
	S98DEVICETYPE_PSG  = 1,
	S98DEVICETYPE_OPN  = 2,
	S98DEVICETYPE_OPN2 = 3,
	S98DEVICETYPE_OPNA = 4,
	S98DEVICETYPE_OPM  = 5,
	S98DEVICETYPE_OPLL = 6,
	S98DEVICETYPE_OPL  = 7,
	S98DEVICETYPE_OPL2 = 8,
	S98DEVICETYPE_OPL3 = 9,
	S98DEVICETYPE_MSXA = 0x0a,
	S98DEVICETYPE_SNG  = 0x10,
	S98DEVICETYPE_NONE = 0
};

/* S98 file header */
#define S98_MAGIC_V0	(0x53393830)	/* 'S980' */
#define S98_MAGIC_V1	(0x53393831)	/* 'S981' */
#define S98_MAGIC_V2	(0x53393832)	/* 'S982' */
#define S98_MAGIC_V3	(0x53393833)	/* 'S983' */
#define S98_MAGIC_VZ	(0x5339385A)	/* 'S98Z' */
#define S98_OFS_MAGIC		(0x00)
#define S98_OFS_TIMER_INFO1	(0x04)
#define S98_OFS_TIMER_INFO2	(0x08)
#define S98_OFS_COMPRESSING	(0x0C)
#define S98_OFS_OFSTITLE	(0x10)
#define S98_OFS_OFSDATA		(0x14)
#define S98_OFS_OFSLOOP		(0x18)
#define S98_OFS_DEVICECOUNT	(0x1C)
#define S98_OFS_DEVICEINFO	(0x20)
